package ovh.herisson.Clyde.EndPoints;


import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import ovh.herisson.Clyde.Services.AuthenticatorService;
import ovh.herisson.Clyde.Services.CurriculumCourseService;
import ovh.herisson.Clyde.Services.CurriculumService;
import ovh.herisson.Clyde.Tables.Curriculum;
import ovh.herisson.Clyde.Tables.CurriculumCourse;
import ovh.herisson.Clyde.Tables.Role;
import ovh.herisson.Clyde.Tables.User;

import java.util.Map;

@RestController
@CrossOrigin(originPatterns = "*", allowCredentials = "true")
public class CurriculumController {


    private final CurriculumService curriculumServ;
    private final AuthenticatorService authServ;

    private final CurriculumCourseService curriculumCourseServ;

    public CurriculumController(CurriculumService curriculumServ, AuthenticatorService authServ, CurriculumCourseService curriculumCourseServ){
        this.curriculumServ = curriculumServ;
        this.authServ = authServ;
        this.curriculumCourseServ = curriculumCourseServ;
    }

    @GetMapping("/curriculum/{id}")
    public ResponseEntity<Curriculum> findById(@PathVariable long id){
        return new ResponseEntity<>(curriculumServ.findById(id), HttpStatus.OK);
    }

    @GetMapping("/curriculums")
    public ResponseEntity<Iterable<Map<String, Object>>> findAllindDepth(){
        return new ResponseEntity<>(curriculumCourseServ.getAllDepthCurriculum(),HttpStatus.OK);
    }

    @GetMapping("/curriculum")
    public ResponseEntity<Iterable<CurriculumCourse>> findAll(){
        return new ResponseEntity<>(curriculumCourseServ.findAll(),HttpStatus.OK);
    }

    /**@PostMapping("/curriculum") //todo now
    public ResponseEntity<String> postCurriculum(@RequestHeader("Authorization") String token,@RequestBody Curriculum curriculum){

        if (!isSecretaryOrAdmin(token)){
            return new UnauthorizedResponse<>("you're not allowed to post a Curriculum");
        }

        CurriculumServ.save(Curriculum);

        return new ResponseEntity<>("created !",HttpStatus.CREATED);
    }**/

}
